<%@page import="org.json.simple.parser.JSONParser"%>
<%@page import="org.json.simple.JSONObject"%>
<%@page import="cz.cvut.felk.aos.oauth.GoogleOAuthHelper"%>
<%@page contentType="text/html" pageEncoding="UTF-8"%>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
    "http://www.w3.org/TR/html4/loose.dtd">

<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
<title>Google OAuth 2.0 v1 Demo</title>
<style>
body {
	font-family: Sans-Serif;
	margin: 1em;
}

.oauthDemo a {
	display: block;
	border-style: solid;
	border-color: #bbb #888 #666 #aaa;
	border-width: 1px 2px 2px 1px;
	background: #ccc;
	color: #333;
	line-height: 2;
	text-align: center;
	text-decoration: none;
	font-weight: 900;
	width: 13em;
}

.oauthDemo pre {
	background: #ccc;
}

.oauthDemo a:active {
	border-color: #666 #aaa #bbb #888;
	border-width: 2px 1px 1px 2px;
	color: #000;
}

.readme {
	padding: .5em;
	background-color: #F9AD81;
	color: #333;
}
</style>
</head>
<body>
    <div class="oauthDemo">
        <%
            /*
            * The GoogleAuthHelper handles all the heavy lifting, and contains all "secrets"
            * required for constructing a google login url.
            */
            final GoogleOAuthHelper helper = new GoogleOAuthHelper();

            if (request.getParameter("code") == null
                    || request.getParameter("state") == null) {
                                
                session.removeAttribute("userInfoJson");
                out.println("<div class=\"readme\">Firstly log to page</div>");
		out.println("<a href='" + helper.buildLoginUrl()
						+ "'>log in with google</a>");
						
                /*
		 * set the secure state token in session to be able to track what we sent to google
		 */
		session.setAttribute("state", helper.getStateToken());

            } else if (request.getParameter("code") != null 
                    && request.getParameter("state") != null
                    && request.getParameter("state").
                    equals(session.getAttribute("state"))) {

		session.removeAttribute("state");
                session.setAttribute("userInfoJson",  helper.getUserInfoJson(request.getParameter("code")));
            } 
                        
            /* 
             * Print user info
             */            
            String userInfoJson = (String) session.getAttribute("userInfoJson");
            if (userInfoJson != null) {
                JSONObject userInfo = (JSONObject) new JSONParser().parse(userInfoJson);
                out.println("<h1>"+userInfo.get("email")+"</h1>");
                out.println("<h2>"+userInfo.get("name")+"</h2>");
                out.println("<img src=\""+userInfo.get("picture")+"\" />");
                out.println("<pre>");
                out.println(userInfoJson);
                out.println("</pre>");
                out.println("<a href=\"index.jsp\">logout</a>");
            }
                        
        %>
    </div>
</body>
</html>
